package tables;

import java.sql.*;

import javax.sql.*;

import java.util.*; 

import database_connection.*;

public class CategoryTable {

	private static final String tableName = "categoria";
	private DBMySQLConnection dbConnection = new DBMySQLConnection();
	private PreparedStatement statement;
	private List<Category> categories = new ArrayList<>();
	
	public CategoryTable() {
		
	}
	
	public void insertNewCategory(final String categoryName) {
		try {
			openConnection();
			String sqlString = "INSERT INTO "+tableName+"(nome_categoria) VALUES(?)";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.setString(1, categoryName);
			statement.executeUpdate();
			closeStatement();
			closeConnection();
			
			Category category = new Category();
			category.setCategoryName(categoryName);
			categories.add(category);
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public List<Category> getCategories() {
		List<Category> catList = new ArrayList<>();
		try {
			openConnection();
			String sqlString = "SELECT * FROM "+tableName;
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				Category category = new Category();
				category.setCategoryName(result.getString("nome_categoria"));
				catList.add(category);
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		return catList;
	}
	
	public void delete(String input){
		try {
			openConnection();
			String sqlString = "DELETE FROM "+tableName+" WHERE nome_categoria='"+input+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	public void openConnection() {
		try {
			dbConnection.connectionToDatabase();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeConnection() {
		try {
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeStatement() {
		try {
			statement.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public static CategoryTable getInstance() {
		return new CategoryTable();
	}
}