package tables;

import java.sql.*;

import javax.sql.*;

import java.util.*;

import database_connection.*;

public class CompetitionTable {

	private final static String tableName = "gara";
	private List<Competition> competitions = new ArrayList<>();
	private DBMySQLConnection dbConnection = new DBMySQLConnection();
	private PreparedStatement statement;
	
	public CompetitionTable() {
		
	}
	
	public void insertNewCompetition(final String[] datas) {
		try {
			openConnection();
			
			String competitionName = datas[1].toString();
			String gymName = datas[2].toString();
			String gymCity = datas[3].toString();
			
			if (GymTable.getInstance().getGymByNameAndCity(gymName, gymCity) != null) {
				Calendar calendar = Calendar.getInstance();
				String sqlString = "INSERT INTO "+tableName+"(data,nome_manifestazione,nomePalestra,cittàPalestra) VALUES(?,?,?,?)";
				statement = dbConnection.getConnection().prepareStatement(sqlString);
				
				String[] data = datas[0].toString().split("/");
				calendar.set(Integer.parseInt(data[0]), Integer.parseInt(data[1])-1, Integer.parseInt(data[2]));
				java.util.Date date = calendar.getTime();
				statement.setDate(1, new java.sql.Date(date.getTime()));
				
				statement.setString(2, competitionName);
				statement.setString(3, gymName);
				statement.setString(4, gymCity);
				statement.executeUpdate();
				closeStatement();
				closeConnection();
				
				Competition comp = new Competition();
				comp.setDate(date);
				comp.setCompetitionName(competitionName);
				comp.setGymCity(gymCity);
				comp.setGymName(gymName);
				competitions.add(comp);
			} else {
				System.out.println("Impossibile aggiungere la gara. La palestra non esiste nel Database.");
			}
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public Competition getCompetitionDetailsByDateAndName(final java.util.Date inputDate, final String inputName) {
		Competition got = new Competition(); 
		try {
			openConnection();
			String sqlString = "SELECT * FROM "+tableName+" WHERE data='"+inputDate+"' AND nome_manifestazione='"+inputName+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				got.setCompetitionName(inputName);
				got.setDate(inputDate);
				got.setGymCity(result.getString("cittàPalestra"));
				got.setGymName(result.getString("nomePalestra"));
			}
			System.out.println("DATA GARA: "+got.getDate());
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return got;
	}
	
	public List<Competition> getAllCompetitionsByGym(final String inputName, final String inputCity) {
		List<Competition> all = new ArrayList<>();
		Competition temp = new Competition();
		try {
			openConnection();
			String sqlString = "SELECT * FROM "+tableName+" WHERE nomePalestra='"+inputName+"' AND cittàPalestra='"+inputCity+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				temp.setGymCity(result.getString("cittàPalestra"));
				temp.setCompetitionName(result.getString("nome_manifestazione"));
				temp.setGymName(result.getString("nomePalestra"));
				temp.setDate(new java.util.Date(result.getDate("data").getTime()));
				
				all.add(temp);
				temp=new Competition();
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		for(Competition a : all){
			System.out.println(a.getCompetitionName());
		}
		return all;
	}
	
	public void updateCompetition(final String[] datas) {
		try {
			openConnection();
			String competitionName = datas[1].toString();
			String gymName = datas[2].toString();
			String gymCity = datas[3].toString();
			
			Calendar calendar = Calendar.getInstance();
			String[] data = datas[0].toString().split("/");
			calendar.set(Integer.parseInt(data[0]), Integer.parseInt(data[1])-1, Integer.parseInt(data[2]));
			java.util.Date date = calendar.getTime();
			
			java.sql.Date newDate = new java.sql.Date(date.getTime());
			String sqlString = "UPDATE "+tableName+" SET data='"+newDate+"' WHERE nome_manifestazione='"+competitionName+"' AND nomePalestra='"+gymName+"' AND cittàPalestra='"+gymCity+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString); 
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void openConnection() {
		try {
			dbConnection.connectionToDatabase();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeConnection() {
		try {
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeStatement() {
		try {
			statement.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void delete(String input, String input2 ,String input3) {
		try {
			openConnection();
			java.sql.Date data;
			data = java.sql.Date.valueOf(input);
			String sqlString = "DELETE FROM "+tableName+" WHERE data='"+data+"' AND nomePalestra='"+input2+"' AND cittàPalestra = '"+input3+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	public static CompetitionTable getInstance() {
		return new CompetitionTable();
	}
}
