package tables;

import java.sql.*;

import javax.sql.*;

import java.util.*;

import database_connection.*;

public class JudgeJuryTable {

	private List<JudgeJurydesk> jjlist = new ArrayList<>();
	private static final String tableName = "giudice_tavolodigiuria";
	private DBMySQLConnection dbConnection = new DBMySQLConnection();
	private PreparedStatement statement;
	
	public JudgeJuryTable() {
		
	}
	
	public void insertNewJudgeJuryTable(final String judgeCode, final String juryTableCode) {
		System.out.println("JJT");
		try {
			openConnection();
			Jurydesk jd = new Jurydesk();
			jd.set(juryTableCode);
			List<Jurydesk> list = JuryTable.getInstance().getAllDesks();
			for (Jurydesk j : list) {
				if(j.getCode().equals(juryTableCode)) {
					if (JudgeTable.getInstance().getJudgesByCF(judgeCode) != null) {
						String sqlString = "INSERT INTO "+tableName+"(CodiceFiscaleGiudice,codiceTavoloGiuria) VALUES(?,?)";
						statement = dbConnection.getConnection().prepareStatement(sqlString);
						statement.setString(1, judgeCode);
						statement.setString(2, juryTableCode);
						statement.executeUpdate();
						closeStatement();
						closeConnection();
						
						JudgeJurydesk jj = new JudgeJurydesk();
						jj.setJudgeCode(judgeCode);
						jj.setJuryTableCode(juryTableCode);
						jjlist.add(jj);
					} else {
						System.out.println("Giudice non esistente.");
					}
				}
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public List<Judge> getAllJudgesInJury(final String inputJuryCode) {
		List<Judge> all = new ArrayList<>();
		Judge temp = null;
		try {
			openConnection();
			List<String> cfs = new ArrayList<>();
			String cf = null;
			String sqlString = "SELECT CodiceFiscaleGiudice FROM "+tableName+" WHERE codiceTavoloGiuria='"+inputJuryCode+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				cf = result.getString("CodiceFiscaleGiudice");
				cfs.add(new String(cf));
			}
			closeStatement();
			closeConnection();
			
			openConnection();
			for (String s : cfs) {
				System.out.println(s);
			}
			for (String s : cfs) {
				String sqlString2 = "SELECT * FROM "+JudgeTable.tableName+" WHERE CF='"+s+"'";
				System.out.println(sqlString2);
				PreparedStatement statement2 = dbConnection.getConnection().prepareStatement(sqlString2);
				ResultSet result2 = statement2.executeQuery();
				while (result2.next()) {
					System.out.println("dentro");
					temp = new Judge();
					temp.setCf(result2.getString("CF"));
					temp.setBirthday(new java.util.Date(result2.getDate("data_di_nascita").getTime()));
					temp.setLocation(result2.getString("luogo_di_nascita"));
					temp.setSurname(result2.getString("cognome"));
					temp.setName(result2.getString("nome"));
					temp.setGymName(result2.getString("nomePalestra"));
					temp.setGymCity(result2.getString("cittàPalestra"));
					all.add(temp);
				}
				statement2.close();
			}
			
			for (Judge j : all) {
				System.out.println(j.getCf());
			}
			
			/*
			while (result.next()) {
				temp = new Judge();
				temp.setCf(result.getString("CodiceFiscaleGiudice"));
				temp.setBirthday(new java.util.Date(result.getDate("data_di_nascita").getTime()));
				temp.setLocation(result.getString("luogo_di_nascita"));
				temp.setSurname(result.getString("cognome"));
				temp.setName(result.getString("name"));
				temp.setGymName(result.getString("nomePalestra"));
				temp.setGymCity(result.getString("cittàPalestra"));
				all.add(temp);
			}*/
			
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return all;
	}
	
	public void openConnection() {
		try {
			dbConnection.connectionToDatabase();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeConnection() {
		try {
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeStatement() {
		try {
			statement.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	public void delete(String input, String input2) {
		//CodiceFiscaleGiudice  codiceTavoloGiuria
		try {
			openConnection();
			String sqlString = "DELETE FROM "+tableName+" WHERE CodiceFiscaleGiudice='"+input+"' AND codiceTavoloGiuria='"+input2+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	public static JudgeJuryTable getInstance() {
		return new JudgeJuryTable();
	}
	
}
