package tables;

import java.sql.*;

import javax.sql.*;

import database_connection.DBMySQLConnection;

import java.util.*;

public class JudgeTable {

	public final static String tableName = "giudice";
	private List<Judge> judgeList = new ArrayList<>();
	private final DBMySQLConnection dbConnection = new DBMySQLConnection();
	private PreparedStatement statement;
	
	public JudgeTable() {
		
	}
	
	public void insertNewJudge(final String[] datas) {		
		try {
			openConnection(); 
			String sqlString = "INSERT INTO "+tableName+"(luogo_di_nascita,data_di_nascita,cognome,nome,CF,nomePalestra,cittàPalestra)"+ " VALUES(?,?,?,?,?,?,?)";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			Calendar calendar = Calendar.getInstance();
			
			String location = datas[0].toString();
			String surname = datas[2].toString();
			String name = datas[3].toString();
			String cf = datas[4].toString();
			String gymName = datas[5].toString();
			String gymCity = datas[6].toString();
			
			if (GymTable.getInstance().getGymByNameAndCity(gymName, gymCity) != null) {
			
				statement.setString(1, datas[0].toString());
				
				String[] data = datas[1].toString().split("/");
				calendar.set(Integer.parseInt(data[0]), Integer.parseInt(data[1])-1, Integer.parseInt(data[2]));
				java.util.Date date = calendar.getTime();
				statement.setDate(2, new java.sql.Date(date.getTime()));
				statement.setString(3, surname);
				statement.setString(4, name);
				statement.setString(5, cf);
				statement.setString(6, gymName);
				statement.setString(7, gymCity);
				
				statement.executeUpdate();	
				closeStatement();
				closeConnection(); 
				Judge judge = new Judge();
				judge.setName(name);
				judge.setSurname(surname);
				judge.setBirthday(date);
				judge.setLocation(location);
				judge.setGymCity(gymCity);
				judge.setGymName(gymName);
				judgeList.add(judge);
			} else {
				System.out.println("Impossibile aggiungere il giudice. La palestra non esiste nel Database.");
			}
			
		} catch(Exception e) {
			closeStatement();
			closeConnection(); 
			e.printStackTrace();
		}
	}
	
	public void deleteJudge(final String inputCf) {
		try {
			openConnection(); 
			String sqlString = "DELETE FROM "+tableName+" WHERE CF='"+inputCf+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public Judge getJudgesByCF(final String cf) {
		Judge judgeFound = new Judge();
		try {
			openConnection();
			String surname = null;
			String name = null;
			String location = null;
			java.util.Date birthDate = null;
			String gymName = null;
			String gymCity = null;
			
			String sqlString = "SELECT * FROM "+tableName+" WHERE CF='"+cf+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			if (result.next()) {
				long secs;
				surname = result.getString("cognome");
				name = result.getString("nome");
				location = result.getString("luogo_di_nascita");
				secs = result.getDate("data_di_nascita").getTime();
                birthDate = new java.util.Date(secs);
                gymName = result.getString("nomePalestra");
                gymCity = result.getString("cittàPalestra");
			}
			
			judgeFound.setBirthday(birthDate);
			judgeFound.setName(name);
			judgeFound.setSurname(surname);
			judgeFound.setGymCity(gymCity);
			judgeFound.setGymName(gymName);
			judgeFound.setLocation(location);
			judgeFound.setCf(cf);
			closeStatement(); 
			closeConnection(); 
		} catch(Exception e) {
			e.printStackTrace();
		}
		return judgeFound;
	}
	
	
	
	public void openConnection() {
		try {
			dbConnection.connectionToDatabase();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeConnection() {
		try {
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeStatement() {
		try {
			statement.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	public static JudgeTable getInstance() {
			
		return new JudgeTable();
	}
	
}
