package tables;

import java.sql.*;

import javax.sql.*;

import java.util.*;

import database_connection.DBMySQLConnection;

public class KataTable {

	private String tableName = "kata";
	private DBMySQLConnection dbConnection;
	private PreparedStatement statement;
	
	private List<Kata> kataList = new ArrayList<>();
	
	public KataTable() {
		dbConnection = new DBMySQLConnection();
	}

	public void insertNewKata(final String inputKataName) {
		try {
			openConnection();
			String sqlString = "INSERT INTO "+tableName+"(nome_Kata) VALUES(?)";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.setString(1, inputKataName);
			statement.executeUpdate();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public List<Kata> getAllKata() {
		List<Kata> allKata = new ArrayList<>();
		try {
			openConnection();
			String sqlString = "SELECT * FROM "+tableName;
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				Kata kata = new Kata();
				kata.setName(result.getString("nome_Kata"));
				allKata.add(kata);
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace(); 
		}
		
		return allKata;
	}
	
	public void openConnection() {
		try {
			dbConnection.connectionToDatabase();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeConnection() {
		try {
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeStatement() {
		try {
			statement.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	public static KataTable getInstance() {
		// TODO Auto-generated method stub
		return new KataTable();
	}

	public void delete(String input) {
		try {
			openConnection();
			String sqlString = "DELETE FROM "+tableName+" WHERE nome_kata='"+input+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
}
