package tables;

import java.util.*;
import java.sql.*;

import javax.sql.*;

import database_connection.DBMySQLConnection;

public class PerformanceTable {

	private String tableName="prova";
	private DBMySQLConnection dbConnection;
	private PreparedStatement statement;
	private List<Performance> performanceList = new ArrayList<>();


	public PerformanceTable() {
		dbConnection = new DBMySQLConnection();
	}
	
	public void insertNewPerformance(final String[] datas) {
		try {
			String kataName = datas[0].toString();
			String athletCF = datas[1].toString();
			String perfName = datas[2].toString();
			String category = datas[3].toString();
			String refreeCF = datas[4].toString();
			String tatamiCode = datas[5].toString();
			String vote = datas[6].toString();
			
			openConnection();
			String sqlString = "INSERT INTO "+tableName+"(nomeKata,CodiceFiscaleAtleta,nomeProva,categoria,CodiceFiscaleArbitro,codiceTatami,votazione)"+" VALUES(?,?,?,?,?,?,?)";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			
			if (athletTable.getInstance().getAthletByCF(athletCF) != null) {
				if (RefreeTable.getInstance().getRefreeByCf(refreeCF) != null) {
					List<Kata> katas = KataTable.getInstance().getAllKata();
					for (Kata k : katas) {
						if (k.getName().equals(kataName)) {
							statement.setString(1, kataName);
							statement.setString(2, athletCF);
							statement.setString(3, perfName);
							statement.setString(4, category);
							statement.setString(5, refreeCF);
							statement.setInt(6, Integer.parseInt(tatamiCode));
							statement.setInt(7, Integer.parseInt(vote));
							statement.executeUpdate();
							closeStatement();
							closeConnection();
							Performance performance = new Performance();
							performance.setKataName(kataName);
							performance.setCategoryName(category);
							performance.setRefreeCF(refreeCF);
							performance.setVote(Integer.parseInt(vote));
							performance.setTatamiCode(Integer.parseInt(tatamiCode));
							performance.setPerformanceName(perfName);
							performance.setAthletCF(athletCF);
							performanceList.add(performance);
						}
					}
				} else {
					System.out.println("Impossibile aggiungere la prova. L'arbitro non è presente nel Database.");
				}
			} else {
				System.out.println("Impossibile aggiungere la prova. L'atleta non è presente nel Database.");
			}
			
			openConnection();
			
			
			
			
			
				
			
			
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	
	public List<String> getAthletsOnTatami(final int inputTatamiCode) {
		List<String> all = new ArrayList<>();
		try {
			openConnection();
			String sqlString = "SELECT CodiceFiscaleAtleta FROM "+tableName+" WHERE codiceTatami='"+inputTatamiCode+"'";
			System.out.println(sqlString);
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				String s = result.getString("CodiceFiscaleAtleta");
				all.add(s);
			}
			closeStatement();
			closeConnection();
			
			openConnection();
			String name = null;
			String surname = null;
			String birthDay = null;
			String location = null;
			String sex = null;
			String gymCity = null;
			String gymName = null;
			
			for (String s2 : all) {
				String sqlString2 = "SELECT * FROM "+athletTable.tableName+" WHERE CF='"+s2+"'";
				statement = dbConnection.getConnection().prepareStatement(sqlString2);
				ResultSet result2 = statement.executeQuery();
				while (result2.next()) {
					name = result2.getString("nome");
					surname = result2.getString("cognome");
					birthDay = result2.getString("data_di_nascita");
					location = result2.getString("luogo_di_nascita");
					sex = result2.getString("sesso");
					gymCity = result2.getString("cittàPalestra");
					gymName = result2.getString("nomePalestra");
					System.out.println("Nome: "+name+"; Cognome: "+surname+"; Data nascita: "+birthDay+""
							+ "Luogo di nascita: "+location+"; Sesso: "+sex+"; Palestra: "+gymName+" "+gymCity); 
				}
			}
			
			
			
		} catch(Exception e) {
			e.printStackTrace();
		}
		return all;
	}
	
	public int getBestVote(final String inputCf) {
		int vote=0;
		try {
			openConnection();
			String sqlString = "SELECT SUM(votazione) as sumVote FROM "+tableName+" WHERE CodiceFiscaleAtleta='"+inputCf+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			if (result.next()&&vote<result.getInt(1)) {
				vote = result.getInt(1);
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return vote;
	}
	public int getSumVotesAthlet(final String inputCf) {
		int vote=0;
		try {
			openConnection();
			String sqlString = "SELECT SUM(votazione) as sumVote FROM "+tableName+" WHERE CodiceFiscaleAtleta='"+inputCf+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			if (result.next()) {
				vote = result.getInt(1);
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return vote;
	}
	

	public Athletes getBestAthlet(String categoria) {

		Athletes at = new Athletes();
		try {
			int voto = 0;
			openConnection();

			String nestedSqlString = "SELECT MAX(votazione) AS maxVote FROM "+tableName+" WHERE categoria ='"+categoria+"'";
			statement = dbConnection.getConnection().prepareStatement(nestedSqlString);
			ResultSet result = statement.executeQuery();
			if (result.next()) {
				voto = result.getInt("maxVote");
			}

			closeStatement();
			closeConnection();
			
			openConnection(); 
			String cfToFind = null;
			String findCfQuery = "SELECT CodiceFiscaleAtleta FROM "+tableName+" WHERE votazione='"+voto+"'";
			statement = dbConnection.getConnection().prepareStatement(findCfQuery);
			ResultSet result2 = statement.executeQuery();
			if (result2.next()) {
				cfToFind = result2.getString("CodiceFiscaleAtleta");
			}
			System.out.println("TOFIND: "+cfToFind);
			closeStatement();
			closeConnection();
			
			openConnection();

			String athletDataQuery = "SELECT * FROM "+athletTable.tableName+" WHERE CF='"+cfToFind+"'";
			statement = dbConnection.getConnection().prepareStatement(athletDataQuery);
			ResultSet result3 = statement.executeQuery();
			while (result3.next()) {
				at.setName(result3.getString("nome"));
				at.setSurname(result3.getString("cognome"));
				at.setLocation(result3.getString("luogo_di_nascita"));
				at.setCf(result3.getString("CF"));
			}
			
			closeStatement();
			closeConnection(); 
		} catch(Exception e) {
			e.printStackTrace();
		}
		return at;
	}
	
	public void getDetailsAndAnagraphics(final String cf) {
		List<Performance> perfList = new ArrayList<>();
		try {
			String athletCF = null;
			openConnection();
			String sqlString = "SELECT * FROM "+tableName+" WHERE CodiceFiscaleAtleta='"+cf+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				Performance performance = new Performance();
				performance.setAthletCF(result.getString("CodiceFiscaleAtleta"));
				performance.setPerformanceName(result.getString("nomeProva"));
				performance.setKataName(result.getString("nomeKata"));
				performance.setCategoryName(result.getString("categoria"));
				performance.setTatamiCode(result.getInt("codiceTatami"));
				performance.setVote(result.getInt("votazione"));
				performance.setRefreeCF(result.getString("CodiceFiscaleArbitro"));
				perfList.add(performance);
			}
			closeStatement();
			closeConnection();
			openConnection();
			String name = null;
			String surname = null;
			String birthDay = null;
			String location = null;
			String sex = null;
			String gymCity = null;
			String gymName = null;
			
			String nestedSqlString = "SELECT * FROM "+athletTable.tableName+" "
					+ "WHERE CF='"+cf+"'";
			PreparedStatement stmt = dbConnection.getConnection().prepareStatement(nestedSqlString);
			ResultSet res2 = stmt.executeQuery();
			while (res2.next()) {
				name = res2.getString("nome");
				surname = res2.getString("cognome");
				birthDay = res2.getString("data_di_nascita");
				location = res2.getString("luogo_di_nascita");
				sex = res2.getString("sesso");
				gymCity = res2.getString("cittàPalestra");
				gymName = res2.getString("nomePalestra");
			}
			System.out.println(cf+ " "+ name + " " +surname+ " " +birthDay +" "+sex+ " " + location + " "+gymCity + " "+ gymName);
			for (Performance p : perfList) {
				System.out.println("Kata eseguito: "+p.getKataName()+", Categoria: "+p.getCategoryName()+", "
						+ "Arbitro: "+p.getRefreeCF()+", Tatami numero: "+p.getTatamiCode()+", Voto: "+p.getVote()+", Nome prova "+p.getPerformanceName());
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void deletePerformanceUnderPoints() {
		try {
			openConnection();
			String sqlString = "DELETE FROM "+tableName+" WHERE votazione<=5";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public List<Performance> getPerformanceByAthletCF(final String inputCf) {
		List<Performance> perfList = new ArrayList<>();
		try {
			openConnection();
			String sqlString = "SELECT * FROM "+tableName+" WHERE CodiceFiscaleAtleta='"+inputCf+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				Performance performance = new Performance();
				performance.setAthletCF(result.getString("CodiceFiscaleAtleta"));
				performance.setPerformanceName(result.getString("nomeProva"));
				performance.setKataName(result.getString("nomeKata"));
				performance.setCategoryName(result.getString("categoria"));
				performance.setTatamiCode(result.getInt("codiceTatami"));
				performance.setVote(result.getInt("votazione"));
				performance.setRefreeCF(result.getString("CodiceFiscaleArbitro"));
				perfList.add(performance);
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return perfList;
	}
	
	public void openConnection() {
		try {
			dbConnection.connectionToDatabase();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeConnection() {
		try {
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeStatement() {
		try {
			statement.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void delete(String input, String input2 ,String input3) {
		try {
			//nomeKatacodiceFiscaleAtletanomeProva
			openConnection();
			String sqlString = "DELETE FROM "+tableName+" WHERE nomeKata='"+input+"' AND CodiceFicaleAtleta='"+input2+"' AND nomeProva = '"+input3+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	public static PerformanceTable getInstance() {
		
		return new PerformanceTable();
	}
	

}



