package tables;

import database_connection.DBMySQLConnection;

import java.util.Calendar;
import java.util.Date;
import java.sql.*;
import java.util.*;

import javax.sql.*;

public class athletTable {

	private DBMySQLConnection dbConnection;

	public final static String tableName = "atleta";
	
	private List<Athletes> athletesList = new ArrayList<>();
	
	private PreparedStatement statement;
	
	public athletTable() {
		dbConnection = new DBMySQLConnection();
	}
	
	public void insertNewAthlet(final String[] datas) {
		dbConnection.connectionToDatabase();
		try {
			String sqlString = "INSERT INTO "+tableName+"(luogo_di_nascita,data_di_nascita,cognome,nome,CF,grado_Dan,sesso,nomePalestra,cittàPalestra,nomeCategoria)"+ " VALUES(?,?,?,?,?,?,?,?,?,?)";
			PreparedStatement statement = dbConnection.getConnection().prepareStatement(sqlString);
			Calendar calendar = Calendar.getInstance();
			
			String location = datas[0].toString();
			String surname = datas[2].toString();
			String name = datas[3].toString();
			String cf = datas[4].toString();
			String dan = datas[5].toString();
			String sex = datas[6].toString();
			String gymName = datas[7].toString();
			String gymCity = datas[8].toString();
			String categoryName = datas[9].toString();
			
			//da rivedere la parte delle categorie
		if ((GymTable.getInstance().getGymByNameAndCity(gymName, gymCity) != null) || (CategoryTable.getInstance().getCategories().contains(categoryName))) {
				statement.setString(1, datas[0].toString());
				
				String[] data = datas[1].toString().split("/");
				calendar.set(Integer.parseInt(data[0]), Integer.parseInt(data[1])-1, Integer.parseInt(data[2]));
				java.util.Date date = calendar.getTime();
				statement.setDate(2, new java.sql.Date(date.getTime()));
				statement.setString(3, surname);
				statement.setString(4, name);
				statement.setString(5, cf);
				statement.setInt(6, Integer.parseInt(dan));
				statement.setString(7, sex);
				statement.setString(8, gymName);
				statement.setString(9, gymCity);
				statement.setString(10, categoryName);
				
				statement.executeUpdate();
				statement.close();
				dbConnection.getConnection().close();
				
				Athletes athlet = new Athletes();
				athlet.setName(name);
				athlet.setSurname(surname);
				athlet.setBirthDate(date);
				athlet.setLocation(location);
				athlet.setGymCity(gymCity);
				athlet.setGymName(gymName);
				athletesList.add(athlet);
			} else {
				statement.close();
				dbConnection.getConnection().close();
				
				System.out.println("Impossibile aggiungere l'atleta.");
			}
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public int getNumberAthletsInCategory(final String inputCategory) {
		int value=0;
		try {
			openConnection();
			String sqlString = "SELECT nomeCategoria, COUNT(*) FROM "+tableName+" WHERE nomeCategoria='"+inputCategory+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString); 
			ResultSet result = statement.executeQuery(); 
			while (result.next()) {
				value = result.getInt(2);
			}
			closeStatement();
			closeConnection();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return value;
	}
	
	public List<Athletes> getAthletes() {
		return athletesList;
	}
	
	public Athletes getAthletByCF(final String cfToFind) {
		Athletes athlet = null;
		try {
			openConnection();
			String sqlString = "SELECT * FROM "+tableName+" WHERE CF = '"+cfToFind+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			if (result.next()) {
				athlet = new Athletes();
				long secs;
				java.util.Date birthDate;
				athlet.setLocation(result.getString("luogo_di_nascita"));
				secs = result.getDate("data_di_nascita").getTime();
                birthDate = new java.util.Date(secs);
                athlet.setBirthDate(birthDate);
                athlet.setName(result.getString("nome"));
                athlet.setSurname(result.getString("cognome"));
                athlet.setCf(result.getString("CF"));
                athlet.setDan(result.getString("grado_Dan"));
                athlet.setSex(result.getString("sesso"));
                athlet.setGymName(result.getString("nomePalestra"));
                athlet.setGymCity(result.getString("cittàPalestra"));
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return athlet;
	}
	
	public List<Athletes> getAthletesByGym(final String inputGymName, final String inputGymCity) {
		List<Athletes> athlet = new ArrayList<>();
		try {
			openConnection();
			String sqlString = "SELECT * FROM "+tableName+" WHERE nomePalestra = '"+inputGymName+"' AND cittàPalestra='"+inputGymCity+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				Athletes temp = new Athletes();
				long secs;
				java.util.Date birthDate;
				System.out.println(result.getString("luogo_di_nascita"));
				temp.setLocation(result.getString("luogo_di_nascita"));
				secs = result.getDate("data_di_nascita").getTime();
                birthDate = new java.util.Date(secs);
                temp.setBirthDate(birthDate);
                temp.setName(result.getString("nome"));
                temp.setSurname(result.getString("cognome"));
                temp.setCf(result.getString("CF"));
                temp.setDan(result.getString("grado_Dan"));
                temp.setSex(result.getString("sesso"));
                temp.setGymName(result.getString("nomePalestra"));
                temp.setGymCity(result.getString("cittàPalestra"));
                athlet.add(temp);
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return athlet;
	}
	
	/*public List<Athletes> getAthletesByGym(final ResultSet result, final String inputGymName, final String inputGymCity) {
		List<Athletes> athlet = new ArrayList<>();
		try {
			dbConnection.connectionToDatabase();
			String sqlString = "SELECT * FROM "+result+" WHERE nomePalestra = '"+inputGymName+"' AND cittàPalestra='"+inputGymCity+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet newResult = statement.executeQuery();
			while (result.next()) {
				Athletes temp = new Athletes();
				long secs;
				java.util.Date birthDate;
				System.out.println(result.getString("luogo_di_nascita"));
				temp.setLocation(result.getString("luogo_di_nascita"));
				secs = result.getDate("data_di_nascita").getTime();
                birthDate = new java.util.Date(secs);
                temp.setBirthDate(birthDate);
                temp.setName(result.getString("nome"));
                temp.setSurname(result.getString("cognome"));
                temp.setCf(result.getString("CF"));
                temp.setDan(result.getString("grado_Dan"));
                temp.setSex(result.getString("sesso"));
                temp.setGymName(result.getString("nomePalestra"));
                temp.setGymCity(result.getString("cittàPalestra"));
                athlet.add(temp);
			}
			statement.close();
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return athlet;
	}*/
	
	public List<Athletes> getAthletesByNameAndGym(final String inputName, final String inputGymName, final String inputGymCity) {
		List<Athletes> athlets = new ArrayList<>();
		try {
			openConnection();
			String sqlString = "SELECT * FROM "+tableName+" WHERE nome='"+inputName+"' AND nomePalestra='"+inputGymName+"' AND cittàPalestra='"+inputGymCity+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				long secs;
				java.util.Date birthDate;
				Athletes temp = new Athletes();
				temp.setName(result.getString("luogo_di_nascita"));
				secs = result.getDate("data_di_nascita").getTime();
                birthDate = new java.util.Date(secs);
                temp.setBirthDate(birthDate);
                temp.setName(result.getString("nome"));
                temp.setSurname(result.getString("cognome"));
                temp.setCf(result.getString("CF"));
                temp.setDan(result.getString("grado_Dan"));
                temp.setSex(result.getString("sesso"));
                temp.setGymName(result.getString("nomePalestra"));
                temp.setGymCity(result.getString("cittàPalestra"));
                athlets.add(temp);
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return athlets;
	}
	
	public List<Athletes> getAthletesByName(final String inputName) {
		List<Athletes> athlet = new ArrayList<>();
		try {
			
			ResultSet result = getResultAthletesByName(inputName);
			
			while (result.next()) {
				//System.out.println("ENTRATO");
				Athletes temp = new Athletes();
				long secs;
				java.util.Date birthDate;
				//System.out.println(result.getString("luogo_di_nascita"));
				temp.setLocation(result.getString("luogo_di_nascita"));
				secs = result.getDate("data_di_nascita").getTime();
                birthDate = new java.util.Date(secs);
                temp.setBirthDate(birthDate);
                temp.setName(result.getString("nome"));
                temp.setSurname(result.getString("cognome"));
                temp.setCf(result.getString("CF"));
                temp.setDan(result.getString("grado_Dan"));
                temp.setSex(result.getString("sesso"));
                temp.setGymName(result.getString("nomePalestra"));
                temp.setGymCity(result.getString("cittàPalestra"));
                athlet.add(temp);
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		return athlet;
	}
	
	public ResultSet getResultAthletesByName(final String inputName) {
		ResultSet result = null;
		try {
			openConnection();
			String sqlString = "SELECT * FROM "+tableName+" WHERE nome = '"+inputName+"'";
			System.out.println(sqlString);
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			result = statement.executeQuery();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return result;
	}
	
	public void deleteAthlet(final String inputCf) {
		try {
			openConnection();
			String sqlString = "DELETE FROM "+tableName+" WHERE CF='"+inputCf+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void updateAthlet(final String[] datas) {
		try {
			openConnection();
			String location = datas[0].toString();
			String surname = datas[2].toString();
			String name = datas[3].toString();
			String cf = datas[4].toString();
			String dan = datas[5].toString();
			String sex = datas[6].toString();
			String gymName = datas[7].toString();
			String gymCity = datas[8].toString();
			String categoryName = datas[9].toString();
			
			String sqlString = "UPDATE "+tableName+" SET luogo_di_nascita='"+location+"' , sesso='"+sex+"' , cognome='"+surname+"' , nome='"+name+"' "
					+ "nomePalestra='"+gymName+"' , cittàPalestra='"+gymCity+"' , nomeCategoria='"+categoryName+"' , grado_Dan='"+dan+"' WHERE "
							+ "CF='"+cf+"' AND data_di_nascita=1991/01/01"; 
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void openConnection() {
		try {
			dbConnection.connectionToDatabase();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeConnection() {
		try {
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeStatement() {
		try {
			statement.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public static athletTable getInstance() {
		return new athletTable();
	}
	
	//public List<Athletes> 
	
}
